diff --git a/test/unit/group_parameter_test.rb b/test/unit/group_parameter_test.rb
index 67546f958..a4b5fa4d5 100644
--- a/test/unit/group_parameter_test.rb
+++ b/test/unit/group_parameter_test.rb
@@ -28,81 +28,5 @@ class GroupParameterTest < ActiveSupport::TestCase
     assert parameter2.valid?
   end
 
-  def setup_user operation, type = "hostgroups"
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_#{type}"
-      role.permissions = ["#{operation}_#{type}".to_sym]
-      @one.roles = [role]
-      @one.hostgroups.destroy_all
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with create permissions should be able to create when permitted" do
-    setup_user "create", "params"
-    as_admin do
-      @one.hostgroups = [hostgroups(:common)]
-    end
-    record =  GroupParameter.create :name => "dummy", :value => "value", :reference_id => hostgroups(:common).id
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with create permissions should not be able to create when not permitted" do
-    setup_user "create"
-    as_admin do
-      @one.hostgroups = [hostgroups(:common)]
-    end
-    record =  GroupParameter.create :name => "dummy", :value => "value", :reference_id => hostgroups(:unusual).id
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with create permissions should be able to create when unconstrained" do
-    setup_user "create", "params"
-    as_admin do
-      @one.hostgroups.destroy_all
-    end
-    record =  GroupParameter.create :name => "dummy", :value => "value", :reference_id => hostgroups(:common).id
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with view permissions should not be able to create when not permitted" do
-    setup_user "view"
-    record =  GroupParameter.create :name => "dummy", :value => "value", :reference_id => hostgroups(:common).id
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy", "params"
-    record =  GroupParameter.first
-    assert record.destroy
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  GroupParameter.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit", "params"
-    record      =  GroupParameter.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  GroupParameter.first
-    record.name = "renamed"
-    assert !record.save
-  end
 end
 
diff --git a/test/unit/helpers/host_groups_helper_test.rb b/test/unit/helpers/host_groups_helper_test.rb
index 20322766a..958b7a90e 100644
--- a/test/unit/helpers/host_groups_helper_test.rb
+++ b/test/unit/helpers/host_groups_helper_test.rb
@@ -6,6 +6,7 @@ class HostGroupsHelperTest < ActionView::TestCase
 
   test "should have the full string of the parent class if the child is a substring" do
     test_group = Hostgroup.create(:name => "test/st")
+    stubs(:url_for).returns('/some/url')
     assert_match /test\/st/, label_with_link(test_group)
     refute_match /te\/st/, label_with_link(test_group)
   end
diff --git a/test/unit/host_class_test.rb b/test/unit/host_class_test.rb
index aaccddfb9..34ba7e801 100644
--- a/test/unit/host_class_test.rb
+++ b/test/unit/host_class_test.rb
@@ -9,47 +9,4 @@ class HostClassTest < ActiveSupport::TestCase
     EnvironmentClass.create(:puppetclass_id => puppetclasses(:two).id, :environment_id => environments(:production).id )
   end
 
-  test "non-admin user with permission :edit_classes can add puppetclass to host" do
-    # role "manager" has permission :edit_classes
-    User.current.roles << [roles(:manager)]
-    assert_difference('HostClass.count') do
-      host = hosts(:one)
-      puppetclass = puppetclasses(:two)
-      assert Host.my_hosts.include?(host)
-      assert host.update_attributes :puppetclass_ids => (host.puppetclass_ids + Array.wrap(puppetclass.id))
-    end
-  end
-
-  test "non-admin user without permission :edit_classes cannot add puppetclass to host" do
-    # do not assign any role to Current.user
-    assert_difference('HostClass.count', 0) do
-      host = hosts(:one)
-      puppetclass = puppetclasses(:two)
-      assert Host.my_hosts.include?(host)
-      assert_raises(ActiveRecord::RecordNotSaved) do
-        refute host.update_attributes :puppetclass_ids => (host.puppetclass_ids + Array.wrap(puppetclass.id))
-      end
-    end
-  end
-
-  test "non-admin user with permission :edit_classes can remove puppetclass from host" do
-    # role "manager" has permission :edit_classes
-    User.current.roles << [roles(:manager)]
-    assert_difference('HostClass.count', -1) do
-      host = hosts(:one)
-      assert Host.my_hosts.include?(host)
-      assert host.update_attributes :puppetclass_ids => []
-    end
-  end
-
-  test "non-admin user without permission :edit_classes cannot remove puppetclass from host" do
-    # do not assign any role to Current.user
-    assert_difference('HostClass.count', 0) do
-      host = hosts(:one)
-      puppetclass = puppetclasses(:two)
-      assert Host.my_hosts.include?(host)
-      refute host.update_attributes :puppetclass_ids => []
-    end
-  end
-
 end
diff --git a/test/unit/host_parameter_test.rb b/test/unit/host_parameter_test.rb
index cd21fcdcf..2f359dffd 100644
--- a/test/unit/host_parameter_test.rb
+++ b/test/unit/host_parameter_test.rb
@@ -35,83 +35,4 @@ class HostParameterTest < ActiveSupport::TestCase
     assert @parameter2.valid?
   end
 
-  def setup_user operation, type = "params"
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_#{type}"
-      role.permissions = ["#{operation}_#{type}".to_sym]
-      @one.roles      = [role]
-      @one.domains.destroy_all
-      @one.hostgroups.destroy_all
-      @one.user_facts.destroy_all
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with create permissions should be able to create when permitted" do
-    setup_user "create"
-    as_admin do
-      @one.domains = [domains(:mydomain)]
-      @one.save!
-    end
-    host_parameter = HostParameter.create! :name => "dummy", :value => "value", :reference_id => hosts(:one).id
-    assert host_parameter
-  end
-
-  test "user with create permissions should not be able to create when not permitted" do
-    setup_user "create"
-    as_admin do
-      @one.hostgroups = [hostgroups(:common)]
-      @one.save!
-      hosts(:one).update_attribute :hostgroup, hostgroups(:unusual)
-    end
-    record = HostParameter.create :name => "dummy", :value => "value", :reference_id => hosts(:one).id
-    assert record.valid?
-    assert !record.save
-  end
-
-  test "user with create permissions should be able to create when unconstrained" do
-    setup_user "create"
-    as_admin do
-      @one.domains.destroy_all
-    end
-    host_parameter = HostParameter.create! :name => "dummy", :value => "value", :reference_id => hosts(:one).id
-    assert host_parameter
-  end
-
-  test "user with view permissions should not be able to create" do
-    setup_user "view", "hosts"
-    record = HostParameter.create :name => "dummy", :value => "value", :reference_id => hosts(:one).id
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record =  HostParameter.first
-    assert record.destroy
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  HostParameter.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  HostParameter.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  HostParameter.first
-    record.name = "renamed"
-    assert !record.save
-  end
 end
diff --git a/test/unit/host_test.rb b/test/unit/host_test.rb
index 692ea11c0..355e4f409 100644
--- a/test/unit/host_test.rb
+++ b/test/unit/host_test.rb
@@ -351,207 +351,6 @@ class HostTest < ActiveSupport::TestCase
     assert host.disabled?
   end
 
-  def setup_user_and_host
-    @one            = users(:one)
-    @one.hostgroups.destroy_all
-    @one.domains.destroy_all
-    @one.user_facts.destroy_all
-    @one.save!
-    @host           = hosts(:one)
-    @host.owner     = users(:two)
-    @host.save!
-    User.current    = @one
-  end
-
-  def setup_filtered_user
-    # Can't use `setup_user_and_host` as it deletes the UserFacts
-    @one             = users(:one)
-    @one.hostgroups.destroy_all
-    @one.domains.destroy_all
-    @one.user_facts  = [user_facts(:one)]
-    @one.facts_andor = "and"
-    @one.save!
-    User.current    = @one
-  end
-
-  test "host cannot be edited without permission" do
-    setup_user_and_host
-    as_admin do
-      @one.roles = [Role.find_by_name("Viewer")]
-    end
-    assert !@host.update_attributes(:comment => "blahblahblah")
-    assert_match /do not have permission/, @host.errors.full_messages.join("\n")
-  end
-
-  test "any host can be edited when permitted" do
-    setup_user_and_host
-    as_admin do
-      @one.roles      = [Role.find_by_name("Edit hosts")]
-    end
-    assert @host.update_attributes(:comment => "blahblahblah")
-    assert_no_match /do not have permission/, @host.errors.full_messages.join("\n")
-  end
-
-  test "hosts can be edited when domains permit" do
-    setup_user_and_host
-    as_admin do
-      @one.roles      = [Role.find_by_name("Edit hosts")]
-      @one.domains    = [Domain.find_by_name("mydomain.net")]
-    end
-    assert @host.update_attributes(:comment => "blahblahblah")
-    assert_no_match /do not have permission/, @host.errors.full_messages.join("\n")
-  end
-
-  test "hosts cannot be edited when domains deny" do
-    setup_user_and_host
-    as_admin do
-      @one.roles      = [Role.find_by_name("Edit hosts")]
-      @one.domains    = [Domain.find_by_name("yourdomain.net")]
-    end
-    assert !@host.update_attributes(:comment => "blahblahblah")
-    assert_match /do not have permission/, @host.errors.full_messages.join("\n")
-  end
-
-  test "host cannot be created without permission" do
-    setup_user_and_host
-    as_admin do
-      @one.roles = [Role.find_by_name("Viewer")]
-    end
-    host = Host.create(:name => "blahblah", :mac => "aabbecddee19", :ip => "2.3.4.09",
-                       :domain => domains(:mydomain),  :operatingsystem => operatingsystems(:centos5_3),
-                       :architecture => architectures(:x86_64), :environment => environments(:production), :puppet_proxy => smart_proxies(:puppetmaster),
-                       :subnet => subnets(:one), :disk => "empty partition")
-    assert host.new_record?
-    assert_match /do not have permission/, host.errors.full_messages.join("\n")
-  end
-
-  test "any host can be created when permitted" do
-    setup_user_and_host
-    as_admin do
-      @one.roles = [Role.find_by_name("Create hosts")]
-    end
-    host = Host.create(:name => "blahblah", :mac => "aabbecddee19", :ip => "2.3.4.11",
-                       :domain => domains(:mydomain),  :operatingsystem => operatingsystems(:centos5_3),  :puppet_proxy => smart_proxies(:puppetmaster),
-                       :architecture => architectures(:x86_64), :environment => environments(:production),
-                       :subnet => subnets(:one), :disk => "empty partition")
-    assert !host.new_record?
-    assert_no_match /do not have permission/, host.errors.full_messages.join("\n")
-  end
-
-  test "hosts can be created when hostgroups permit" do
-    setup_user_and_host
-    as_admin do
-      @one.roles      = [Role.find_by_name("Create hosts")]
-      @one.hostgroups = [Hostgroup.find_by_name("Common")]
-    end
-    host = Host.create(:name => "blahblah", :mac => "aabbecddee19", :ip => "2.3.4.4",
-                       :domain => domains(:mydomain),  :operatingsystem => operatingsystems(:centos5_3),
-                       :architecture => architectures(:x86_64), :environment => environments(:production),
-                       :subnet => subnets(:one),
-                       :disk => "empty partition", :hostgroup => hostgroups(:common))
-    assert !host.new_record?
-    assert_no_match /do not have permission/, host.errors.full_messages.join("\n")
-  end
-
-  test "hosts cannot be created when hostgroups deny" do
-    setup_user_and_host
-    as_admin do
-      @one.roles      = [Role.find_by_name("Create hosts")]
-      @one.hostgroups = [Hostgroup.find_by_name("Unusual")]
-    end
-    host = Host.create(:name => "blahblah", :mac => "aabbecddee19", :ip => "2.3.4.9",
-                       :domain => domains(:mydomain),  :operatingsystem => operatingsystems(:centos5_3),
-                       :architecture => architectures(:x86_64), :environment => environments(:production),
-                       :subnet => subnets(:one),
-                       :disk => "empty partition", :hostgroup => hostgroups(:common))
-    assert host.new_record?
-    assert_match /do not have permission/, host.errors.full_messages.join("\n")
-  end
-
-  test "host cannot be destroyed without permission" do
-    setup_user_and_host
-    as_admin do
-      @one.roles = [Role.find_by_name("Viewer")]
-    end
-    assert !@host.destroy
-    assert_match /do not have permission/, @host.errors.full_messages.join("\n")
-  end
-
-  test "any host can be destroyed when permitted" do
-    setup_user_and_host
-    as_admin do
-      @one.roles = [Role.find_by_name("Destroy hosts")]
-      @host.host_classes.delete_all
-      assert @host.destroy
-    end
-    assert_no_match /do not have permission/, @host.errors.full_messages.join("\n")
-  end
-
-  test "hosts can be destroyed when ownership permits" do
-    setup_user_and_host
-    as_admin do
-      @one.roles = [Role.find_by_name("Destroy hosts")]
-      @host.update_attribute :owner,  users(:one)
-      @host.host_classes.delete_all
-      assert @host.destroy
-    end
-    assert_no_match /do not have permission/, @host.errors.full_messages.join("\n")
-  end
-
-  test "hosts cannot be destroyed when ownership denies" do
-    setup_user_and_host
-    as_admin do
-      @one.roles   = [Role.find_by_name("Destroy hosts")]
-      @one.domains = [domains(:yourdomain)] # This does not grant access but does ensure that access is constrained
-      @host.owner  = users(:two)
-      @host.save!
-    end
-    assert !@host.destroy
-    assert_match /do not have permission/, @host.errors.full_messages.join("\n")
-  end
-
-  test "fact filters restrict the my_hosts scope" do
-    setup_filtered_user
-    assert_equal 1, Host.my_hosts.count
-    assert_equal 'my5name.mydomain.net', Host.my_hosts.first.name
-  end
-
-  test "sti types altered in memory with becomes are still contained in my_hosts scope" do
-    class Host::Valid < Host::Base ; belongs_to :domain ; end
-    h = Host::Valid.new :name => "mytestvalidhost.foo.com"
-    setup_user_and_host
-    as_admin do
-      @one.domains = [domains(:yourdomain)] # ensure it matches the user filters
-      h.update_attribute :domain,  domains(:yourdomain)
-    end
-    h_new = h.becomes(Host::Managed) # change the type to break normal AR `==` method
-    assert Host::Base.my_hosts.include?(h_new)
-  end
-
-  test "host can be edited when user fact filter permits" do
-    setup_filtered_user
-    as_admin do
-      @one.roles  = [Role.find_by_name("Edit hosts")]
-      @host       = hosts(:one)
-      @host.owner = users(:two)
-      @host.save!
-    end
-    assert @host.update_attributes(:comment => "blahblahblah")
-    assert_no_match /do not have permission/, @host.errors.full_messages.join("\n")
-  end
-
-  test "host cannot be edited when user fact filter denies" do
-    setup_filtered_user
-    as_admin do
-      @one.roles  = [Role.find_by_name("Edit hosts")]
-      @host       = hosts(:two)
-      @host.owner = users(:two)
-      @host.save!
-    end
-    assert !@host.update_attributes(:comment => "blahblahblah")
-    assert_match /do not have permission/, @host.errors.full_messages.join("\n")
-  end
-
   test "a fqdn Host should be assigned to a domain if such domain exists" do
     domain = domains(:mydomain)
     host = Host.create :name => "host.mydomain.net", :mac => "aabbccddeaff", :ip => "2.3.04.03",
@@ -941,9 +740,13 @@ class HostTest < ActiveSupport::TestCase
     @one = users(:one)
     # add permission for user :one
     as_admin do
+      filter = FactoryGirl.build(:filter)
+      filter.permissions = [ Permission.find_by_name('edit_hosts') ]
+      filter.save!
       role = Role.find_or_create_by_name :name => "testing_role"
-      role.permissions = [:edit_hosts]
-      @one.roles = [role]
+      role.filters = [ filter ]
+      role.save!
+      @one.roles = [ role ]
       @one.save!
     end
     h = hosts(:one)
diff --git a/test/unit/hostgroup_class_test.rb b/test/unit/hostgroup_class_test.rb
index ac1ef39c1..337531fb6 100644
--- a/test/unit/hostgroup_class_test.rb
+++ b/test/unit/hostgroup_class_test.rb
@@ -18,47 +18,4 @@ class HostgroupClassTest < ActiveSupport::TestCase
       end
     end
   end
-
-  test "non-admin user with permission :edit_hostgroups can add puppetclass to hostgroup" do
-    # role "manager" has permission :edit_classes
-    User.current.roles << [roles(:manager)]
-    assert_difference('HostgroupClass.count') do
-      hostgroup = hostgroups(:common)
-      puppetclass = puppetclasses(:two)
-      assert Hostgroup.my_groups.include?(hostgroup)
-      assert hostgroup.update_attributes :puppetclass_ids => (hostgroup.puppetclass_ids + Array.wrap(puppetclass.id))
-    end
-  end
-
-  test "non-admin user without permission :edit_hostgroups cannot add puppetclass to hostgroup" do
-    # do not assign any role to Current.user
-    assert_difference('HostgroupClass.count', 0) do
-      hostgroup = hostgroups(:common)
-      puppetclass = puppetclasses(:two)
-      assert Hostgroup.my_groups.include?(hostgroup)
-      assert_raises(ActiveRecord::RecordNotSaved) do
-        refute hostgroup.update_attributes :puppetclass_ids => (hostgroup.puppetclass_ids + Array.wrap(puppetclass.id))
-      end
-    end
-  end
-
-  test "non-admin user with permission :edit_hostgroups can remove puppetclass from hostgroup" do
-    # role "manager" has permission :edit_classes
-    User.current.roles << [roles(:manager)]
-    assert_difference('HostgroupClass.count', -1) do
-      hostgroup = hostgroups(:common)
-      assert Hostgroup.my_groups.include?(hostgroup)
-      assert hostgroup.update_attributes :puppetclass_ids => []
-    end
-  end
-
-  test "non-admin user without permission :edit_hostgroups cannot remove puppetclass from hostgroup" do
-    # do not assign any role to Current.user
-    assert_difference('HostgroupClass.count', 0) do
-      hostgroup = hostgroups(:common)
-      puppetclass = puppetclasses(:two)
-      assert Hostgroup.my_groups.include?(hostgroup)
-      refute hostgroup.update_attributes :puppetclass_ids => []
-    end
-  end
 end
diff --git a/test/unit/hostgroup_test.rb b/test/unit/hostgroup_test.rb
index e41b88d7c..d56215160 100644
--- a/test/unit/hostgroup_test.rb
+++ b/test/unit/hostgroup_test.rb
@@ -28,64 +28,7 @@ class HostgroupTest < ActiveSupport::TestCase
   end
 
   def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_hostgroup"
-      role.permissions = ["#{operation}_hostgroups".to_sym]
-      @one.roles = [role]
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with create permissions should be able to create" do
-    setup_user "create"
-    record =  Hostgroup.create :name => "dummy"
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with view permissions should not be able to create" do
-    setup_user "view"
-    record =  Hostgroup.create :name => "dummy"
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record = hostgroups(:common)
-    as_admin do
-      record.hosts.destroy_all
-      record.hostgroup_classes.destroy_all
-      assert record.destroy
-    end
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record = hostgroups(:common)
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  Hostgroup.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  Hostgroup.first
-    record.name = "renamed"
-    as_admin do
-      record.hosts.destroy_all
-    end
-    assert !record.save
-    assert record.valid?
+    super operation, "hostgroups"
   end
 
   test "should be able to nest a group parameters" do
diff --git a/test/unit/lookup_value_test.rb b/test/unit/lookup_value_test.rb
index d4408a6d8..009fb0a1d 100644
--- a/test/unit/lookup_value_test.rb
+++ b/test/unit/lookup_value_test.rb
@@ -38,14 +38,15 @@ class LookupValueTest < ActiveSupport::TestCase
     end
   end
 
-  test "non-admin user cannot create lookup value if user has no matching host/hostgroup" do
-    # Host.my_hosts returns only hosts(:one)
+  test "non-admin user cannot view only his hosts restricted by filters" do
+    # Host.authorized(:view_hosts, Host) returns only hosts(:one)
     user = users(:one)
+    role = FactoryGirl.create(:role, :name => 'user_view_host_by_ip')
+    FactoryGirl.create(:filter, :role => role, :permissions => [Permission.find_by_name(:view_hosts)], :search => 'facts.ipaddress = 10.0.19.33')
+    user.roles<< [ role ]
     as_user :one do
-      refute Host.my_hosts.where(:name => hosts(:two).name).exists?
-      refute Hostgroup.my_groups.where(:name => hosts(:two).try(:hostgroup).try(:name)).exists?
-      lookup_value = LookupValue.new(valid_attrs2)
-      refute lookup_value.save
+      assert Host.authorized(:view_hosts, Host).where(:name => hosts(:one).name).exists?
+      refute Host.authorized(:view_hosts, Host).where(:name => hosts(:two).name).exists?
     end
   end
 
@@ -67,47 +68,12 @@ class LookupValueTest < ActiveSupport::TestCase
     end
   end
 
-  test "cannot update lookup value if user has no matching host/hostgroup" do
-    # Host.my_hosts returns only hosts(:one)
-    user = users(:one)
-    as_user :one do
-      refute Host.my_hosts.where(:name => hosts(:two).name).exists?
-      refute Hostgroup.my_groups.where(:name => hosts(:two).try(:hostgroup).try(:name)).exists?
-      refute lookup_values(:hosttwo).update_attributes(:value => "9000")
-    end
-  end
-
-  test "can create lookup value if user has matching host " do
-    # Host.my_hosts returns only hosts(:one)
-    user = users(:one)
-    as_user :one do
-      assert Host.my_hosts.where(:name => hosts(:one).name).exists?
-      refute Hostgroup.my_groups.where(:name => hosts(:one).try(:hostgroup).try(:name)).exists?
-      lookup_value = LookupValue.new(valid_attrs1)
-      assert_difference('LookupValue.count') do
-        assert lookup_value.save
-      end
-    end
-  end
-
-  test "can update lookup value if user has matching host " do
-    # Host.my_hosts returns only hosts(:one)
-    user = users(:one)
-    as_user :one do
-      assert Host.my_hosts.where(:name => hosts(:one).name).exists?
-      refute Hostgroup.my_groups.where(:name => hosts(:one).try(:hostgroup).try(:name)).exists?
-      assert lookup_values(:one).update_attributes(:value => "9000")
-    end
-  end
-
   test "can create lookup value if user has matching hostgroup " do
-    # Host.my_hosts returns only hosts(:one)
     user = users(:one)
     as_admin do
       assert user.hostgroups << hostgroups(:common)
     end
     as_user :one do
-      assert Hostgroup.my_groups.where(:name => "Common").exists?
       lookup_value = LookupValue.new(valid_attrs3)
       assert_difference('LookupValue.count') do
         assert lookup_value.save
@@ -115,18 +81,6 @@ class LookupValueTest < ActiveSupport::TestCase
     end
   end
 
-  test "can update lookup value if user has matching hostgroup " do
-    # Host.my_hosts returns only hosts(:one)
-    user = users(:one)
-    as_admin do
-      assert user.hostgroups << hostgroups(:common)
-    end
-    as_user :one do
-      assert Hostgroup.my_groups.where(:name => "Common").exists?
-      assert lookup_values(:hostgroupcommon).update_attributes(:value => "9000")
-    end
-  end
-
   test "smart class parameter accepts valid data" do
     as_admin do
       lk = LookupValue.new(:value => "---\nfoo:\n  bar: baz", :match => "hostgroup=Common", :lookup_key => lookup_keys(:six))
diff --git a/test/unit/medium_test.rb b/test/unit/medium_test.rb
index 7a7635938..08b3fe566 100644
--- a/test/unit/medium_test.rb
+++ b/test/unit/medium_test.rb
@@ -60,67 +60,6 @@ class MediumTest < ActiveSupport::TestCase
     assert !medium.destroy
   end
 
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_media"
-      role.permissions = ["#{operation}_media".to_sym]
-      @one.roles = [role]
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with create permissions should be able to create" do
-    setup_user "create"
-    record =  Medium.create :name => "dummy", :path => "http://hello"
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with view permissions should not be able to create" do
-    setup_user "view"
-    record =  Medium.create :name => "dummy", :path => "http://hello"
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record =  Medium.first
-    as_admin do
-      record.hosts.delete_all
-      record.hostgroups.delete_all
-      assert record.destroy
-    end
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  Medium.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  Medium.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  Medium.first
-    record.name = "renamed"
-    as_admin do
-      record.hosts.delete_all
-    end
-    assert !record.save
-    assert record.valid?
-  end
-
   test "os family can be one of defined os families" do
     medium = Medium.new :name => "dummy", :path => "http://hello", :os_family => Operatingsystem.families[0]
     assert medium.valid?
diff --git a/test/unit/model_test.rb b/test/unit/model_test.rb
index 352e2f023..e1c4cb91f 100644
--- a/test/unit/model_test.rb
+++ b/test/unit/model_test.rb
@@ -26,65 +26,4 @@ class ModelTest < ActiveSupport::TestCase
     m.hosts << host
     assert !m.destroy
   end
-
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_models"
-      role.permissions = ["#{operation}_models".to_sym]
-      @one.roles = [role]
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with create permissions should be able to create" do
-    setup_user "create"
-    record =  Model.create :name => "dummy"
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with view permissions should not be able to create" do
-    setup_user "view"
-    record =  Model.create :name => "dummy"
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record =  Model.first
-    as_admin do
-      record.hosts.destroy_all
-    end
-    assert record.destroy
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  Model.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  Model.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  Model.first
-    record.name = "renamed"
-    as_admin do
-      record.hosts.destroy_all
-    end
-    assert !record.save
-    assert record.valid?
-  end
-
 end
diff --git a/test/unit/operatingsystem_test.rb b/test/unit/operatingsystem_test.rb
index c55aec471..19d59c533 100644
--- a/test/unit/operatingsystem_test.rb
+++ b/test/unit/operatingsystem_test.rb
@@ -76,67 +76,6 @@ class OperatingsystemTest < ActiveSupport::TestCase
     assert operating_system.to_s == operating_system.to_label
   end
 
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_operatingsystems"
-      role.permissions = ["#{operation}_operatingsystems".to_sym]
-      @one.roles = [role]
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with create permissions should be able to create" do
-    setup_user "create"
-    record =  Operatingsystem.create :name => "dummy", :major => 7
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with view permissions should not be able to create" do
-    setup_user "view"
-    record =  Operatingsystem.create :name => "dummy", :major => 7
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record =  Operatingsystem.first
-    as_admin do
-      record.hosts.delete_all
-      record.hostgroups.delete_all
-      assert record.destroy
-    end
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  Operatingsystem.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  Operatingsystem.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  Operatingsystem.first
-    record.name = "renamed"
-    as_admin do
-      record.hosts.destroy_all
-    end
-    assert !record.save
-    assert record.valid?
-  end
-
   test "should find by fullname string" do
     str = "Redhat 6.1"
     os = Operatingsystem.find_by_fullname(str)
@@ -166,7 +105,6 @@ class OperatingsystemTest < ActiveSupport::TestCase
     assert_equal ["centos 5.3"], medium.operatingsystem_names
   end
 
-
   describe "families" do
     let(:os) { Operatingsystem.new :name => "dummy", :major => 7 }
 
